import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { completeFromList } from '@codemirror/autocomplete';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "!WQYQPOOOeQPO'#CcOOQO'#Ch'#ChOOQO'#Cd'#CdQYQPOOOOQO,58},58}OsQPO,58}OOQO-E6b-E6bOOQO1G.i1G.i",
  stateData: "!R~OZOSPOS~ORQOSQOUPO~ORQOSQOTTOUPO~ORQOSQOTWOUPO~O",
  goto: "t]PPPPPPP^dPPPnXQOPSUQSOQUPTVSUXROPSU",
  nodeNames: "⚠ LineComment Program Identifier String ) ( Application",
  maxTerm: 12,
  nodeProps: [
    ["openedBy", 5,"("],
    ["closedBy", 6,")"]
  ],
  skippedNodes: [0,1],
  repeatNodeCount: 1,
  tokenData: "%Q~R]XYzYZz]^zpqzrs!]st#yxy$byz$g}!O$l!Q![$l!c!}$l#R#S$l#T#o$l~!PSZ~XYzYZz]^zpqz~!`VOr!]rs!us#O!]#O#P!z#P;'S!];'S;=`#s<%lO!]~!zOS~~!}RO;'S!];'S;=`#W;=`O!]~#ZWOr!]rs!us#O!]#O#P!z#P;'S!];'S;=`#s;=`<%l!]<%lO!]~#vP;=`<%l!]~$OSP~OY#yZ;'S#y;'S;=`$[<%lO#y~$_P;=`<%l#y~$gOU~~$lOT~~$qTR~}!O$l!Q![$l!c!}$l#R#S$l#T#o$l",
  tokenizers: [0],
  topRules: {"Program":[0,2]},
  tokenPrec: 0
});

const FLASHILanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Application: delimitedIndent({ closing: ")", align: false }),
            }),
            foldNodeProp.add({
                Application: foldInside,
            }),
            styleTags({
                Identifier: tags.variableName,
                String: tags.string,
                LineComment: tags.lineComment,
                VariableName: tags.variableName,
                FunctionName: tags.variableName,
                "${ }": tags.brace,
            }),
        ],
    }),
    languageData: {
        commentTokens: { line: "#" },
    },
});
const FLASHICompletion = FLASHILanguage.data.of({
    autocomplete: completeFromList([
        { label: "echo", type: "function" },
        { label: "press", type: "function" },
        { label: "set", type: "keyword" },
        { label: "array", type: "keyword" },
    ]),
});
function flashi() {
    return new LanguageSupport(FLASHILanguage, [FLASHICompletion]);
}

export { FLASHICompletion, FLASHILanguage, flashi };
